DECLARE SUB Get_Scale ()
DECLARE SUB plotone ()
DECLARE SUB waiting ()
DECLARE SUB print_Scale ()
DECLARE SUB High_Speed ()
DECLARE SUB Save_All ()
DECLARE SUB save_one ()
DECLARE SUB save ()
DECLARE SUB load_Config ()
DECLARE SUB Save_Config ()
DECLARE SUB get_samples ()
DECLARE SUB LoadMC ()
DECLARE SUB plotit ()
DECLARE SUB Drawtext ()
DECLARE SUB keypress ()
DECLARE SUB Get_Input ()
DECLARE SUB drawscreen ()
DECLARE SUB setupvars ()
DECLARE SUB init_Pocket ()
DECLARE SUB Load_MC ()

'********* System *************
COMMON SHARED prog() AS INTEGER
COMMON SHARED prog_seg AS INTEGER
COMMON SHARED base_address AS INTEGER
COMMON SHARED y() AS INTEGER
COMMON SHARED data_step
COMMON SHARED screen_step
COMMON SHARED number_to_plot
COMMON SHARED screen_offset
COMMON SHARED Value$
COMMON SHARED Sample_Time
COMMON SHARED user_input$
COMMON SHARED Request_String$
COMMON SHARED Scale
COMMON SHARED x_min
COMMON SHARED x_Max
COMMON SHARED y_min
COMMON SHARED y_max
COMMON SHARED Ticks
COMMON SHARED T
COMMON SHARED this_sample
COMMON SHARED data_start

'******** System Flags ********
COMMON SHARED Keypressed
COMMON SHARED Status AS INTEGER
COMMON SHARED Its_Time_To_Sample
COMMON SHARED sampling
COMMON SHARED quitnow
'******** Settings ************
COMMON SHARED Port AS INTEGER
COMMON SHARED Delay_Value AS INTEGER
COMMON SHARED Number_Samples AS INTEGER
COMMON SHARED Samples_per_save
COMMON SHARED Hours_per_Sample
COMMON SHARED Minutes_per_Sample
COMMON SHARED Seconds_per_Sample
COMMON SHARED sample_mode
COMMON SHARED Plot_onoff
COMMON SHARED Filename$
COMMON SHARED Current_Config$
COMMON SHARED auto

'******** Colours *************
COMMON SHARED Trace_Colour
COMMON SHARED Trace_Background_Colour
COMMON SHARED Grid_Colour
COMMON SHARED Centre_Line_Colour
COMMON SHARED Scale_Text_Colour
COMMON SHARED Highlight_Colour
COMMON SHARED Text_Colour
COMMON SHARED Data_Colour
COMMON SHARED Highlight_Colour2
COMMON SHARED Text_Colour2
COMMON SHARED Data_Colour2
COMMON SHARED Msg_Colour
COMMON SHARED Msg_Highlight_Colour

'******** Constants ***********
COMMON SHARED Full_Scale
COMMON SHARED Volt_per_Div
COMMON SHARED Samples_per_Tick

DIM prog(1 TO 32767) AS INTEGER
DIM y(0 TO 32766) AS INTEGER



'Pocket sampler software, version 1.1
'Written in Visual Basic for DOS v1.0
'By Graham Cattley and Jean-Baptiste Cattley
'over a period of a month ending 10/07/96.

'V1.1
'text mode data = 0.00 bug fixed 5/10/96




CLS
CALL setupvars

DEF SEG = VARSEG(prog(1))

FOR i = 0 TO 117
    READ Code
    POKE base_address + i, Code
NEXT
DATA &H55, &H89, &HE5, &H8B, &H76, &H0C, &H8B, &H14
DATA &H8B, &H76, &H0A, &H8B, &H1C, &H42, &H42, &HB8
DATA &H02, &H00, &HEF, &HB8, &H03, &H00, &HEF, &HB8
DATA &H06, &H00, &HEF, &H4A, &HB9, &HFF, &HFF, &HEC
DATA &H24, &H08, &H74, &H08, &H49, &H75, &HF8, &HB0
DATA &HFF, &HE9, &H41, &H00, &H42, &HB0, &H02, &HEE
DATA &H4A, &HEC, &HD0, &HC8, &HD0, &HC8, &HD0, &HC8
DATA &HD0, &HC8, &H24, &H0F, &H88, &HC1, &H42, &HB0
DATA &H03, &HEE, &H4A, &HEC, &H24, &HF0, &H0A, &HC8
DATA &H42, &HB0, &H06, &HEE, &H4A, &H80, &HF1, &H88
DATA &H2E, &H88, &H8F, &H50, &H01, &H8B, &H76, &H08
DATA &H8B, &H04, &H3D, &H00, &H00, &H74, &H09, &HB1
DATA &HFF, &HFE, &HC9, &H75, &HFC, &H48, &H75, &HF7
DATA &H4B, &H75, &HB1, &HB0, &H00, &H8B, &H76, &H06
DATA &H88, &H04, &H5D, &HCA, &H08, &H00


CALL init_Pocket
CLS
CALL drawscreen
CALL Drawtext
Its_Time_To_Sample = 1
this_sample = 1
sampling = 0
IF auto = 1 THEN sampling = 1
DO
    CALL Get_Scale
    CALL keypress
    IF Keypressed = 1 THEN
        Keypressed = 0
        IF Plot_onoff = 1 THEN
           LINE (4, 320)-(636, 472), 0, BF
           LINE (536, 4)-(636, 292), 0, BF
           ELSE

           LOCATE 17, 1
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ")
           PRINT STRING$(79, " ");

        END IF
        CALL Drawtext


    END IF

    IF sample_mode = 1 THEN
        CALL High_Speed
    END IF

    IF sample_mode = 2 THEN
        CALL waiting
    END IF
IF quitnow = 1 THEN EXIT DO
LOOP UNTIL user_input$ = "X"

CALL Save_Config
CLS
SYSTEM
END

SUB drawscreen ()


IF Plot_onoff = 1 THEN
    
    SCREEN 12
    screen_offset = 0

    COLOR Scale_Text_Colour
    LINE (1, 295)-(639, 475), 1, B
    LINE (3, 297)-(637, 473), 1, B
    LINE (533, 1)-(639, 295), 1, B
    LINE (535, 3)-(637, 293), 1, B

    IF Status = 255 THEN

        LINE (x_min - 2, y_min - 2)-(x_Max + 2, y_max + 2), , B
        LINE (x_min, y_min)-(x_Max, y_max), Trace_Background_Colour, BF
        COLOR Trace_Colour
        LOCATE 10, 23: PRINT " Sampler not responding! "

    ELSE


        LINE (x_min - 2, y_min - 2)-(x_Max + 2, y_max + 2), , B
        LINE (x_min, y_min)-(x_Max, y_max), Trace_Background_Colour, BF

        number_of_lines = Full_Scale / Volt_per_Div
        line_spacing = (y_max - y_min) / number_of_lines

        FOR i = number_of_lines TO 0 STEP -1
            grid_y = i * line_spacing + y_min
            LINE (x_min, grid_y)-(x_Max, grid_y), Grid_Colour
        NEXT

        midline = y_min + 128
        LINE (x_min, midline)-(x_Max, midline), Centre_Line_Colour

        IF Number_Samples < 100 THEN
            Ticks = Samples_per_Tick / 10
        ELSE
            IF Number_Samples > 999 THEN
                Ticks = Samples_per_Tick * 10
            ELSE Ticks = Samples_per_Tick
            END IF
        END IF

        FOR i = x_min TO x_Max STEP 500 / (Number_Samples / Ticks)
            LINE (i, midline - 5)-(i, midline + 5), Centre_Line_Colour
        NEXT

        FOR i = x_min TO x_Max STEP 500 / (Number_Samples / (Ticks / 5))
            LINE (i, midline - 3)-(i, midline + 3), Centre_Line_Colour
        NEXT
   
    END IF

END IF


END SUB

SUB Drawtext ()

IF Plot_onoff = 1 THEN

    SCREEN 12
    

    screen_offset = 0
   

    LOCATE 2, 69: COLOR Highlight_Colour2: PRINT "  Pocket"
    LOCATE 3, 69: COLOR Highlight_Colour2: PRINT "  Sampler"
    LOCATE 4, 69: COLOR Highlight_Colour2: PRINT "   v1.1  "
    LOCATE 5, 69: COLOR Highlight_Colour2: PRINT "Electronics"
    LOCATE 6, 69: COLOR Highlight_Colour2: PRINT " Australia"
    LOCATE 7, 69: COLOR Highlight_Colour2: PRINT "August 1996"
    LOCATE 10, 69: COLOR Text_Colour2: PRINT "Volts/Div"
    LOCATE 11, 72: COLOR Data_Colour: PRINT USING "#.##"; Volt_per_Div
    LOCATE 13, 69: COLOR Text_Colour2: PRINT "Samples/Div"
    LOCATE 14, 72: COLOR Data_Colour: PRINT Ticks / 5

    IF sample_mode = 1 THEN
        LOCATE 16, 69: COLOR Text_Colour2: PRINT "   Total   "
        LOCATE 17, 69: COLOR Text_Colour2: PRINT "Sample Time"

        s = Sample_Time * Number_Samples
    
        m$ = "us": m = 1000000
        IF s >= .001 THEN m$ = "ms": m = 1000
        IF s >= 1 THEN m$ = "s": m = 1
    
        LOCATE 18, 70: COLOR Data_Colour: PRINT USING "###.#"; s * m; : PRINT m$
    END IF

    COLOR Scale_Text_Colour

ELSE
    screen_offset = -5
    LOCATE 2, 40: COLOR Highlight_Colour2
    PRINT TAB(30); "  Pocket Sampler v1.0 "
    PRINT TAB(30); "Electronics  Australia"
    PRINT TAB(30); "     August 1996"
        IF Status = 255 THEN
            COLOR Trace_Colour
            LOCATE 10, 29: PRINT " Sampler not responding! "
         ELSE LOCATE 10, 29: PRINT "                         "
        END IF

END IF




LOCATE screen_offset + 22, 45: COLOR Highlight_Colour2: PRINT "P";
COLOR Text_Colour2: PRINT "ort Address:";
LOCATE screen_offset + 22, 60: COLOR Data_Colour2: PRINT HEX$(Port);

LOCATE screen_offset + 23, 45: COLOR Text_Colour2: PRINT "P";
COLOR Highlight_Colour2: PRINT "l";
COLOR Text_Colour2: PRINT "ot:";
LOCATE screen_offset + 23, 60: COLOR Data_Colour2
IF Plot_onoff = 0 THEN PRINT "OFF" ELSE PRINT "ON "

IF sample_mode = 1 THEN
    LOCATE screen_offset + 27, 8: COLOR Text_Colour: PRINT "Speed fa";
    COLOR Highlight_Colour: PRINT "c"; : COLOR Text_Colour: PRINT "tor:";
    COLOR Data_Colour: PRINT Delay_Value;

    LOCATE screen_offset + 27, 36:  PRINT "                                            "
    ELSE
        LOCATE screen_offset + 27, 36: COLOR Msg_Highlight_Colour: PRINT "         <ESC>";
        COLOR Msg_Colour: PRINT "   To stop sampling           ";
END IF

LOCATE screen_offset + 24, 45: COLOR Highlight_Colour2: PRINT "F";
COLOR Text_Colour2: PRINT "ile Name:";
LOCATE screen_offset + 24, 60: COLOR Data_Colour2: PRINT Filename$;

LOCATE screen_offset + 26, 36: COLOR Msg_Highlight_Colour: PRINT "         <SPACE>";
COLOR Msg_Colour: PRINT " To start sampling          ";

LOCATE screen_offset + 28, 36: COLOR Msg_Highlight_Colour: PRINT "         <D>";
COLOR Msg_Colour: PRINT "     To save data to disk       ";

LOCATE screen_offset + 29, 36: COLOR Msg_Highlight_Colour: PRINT "         <X>";
COLOR Msg_Colour: PRINT "     To exit";

LOCATE screen_offset + 22, 8: COLOR Text_Colour: PRINT "Sample m";
COLOR Highlight_Colour: PRINT "o";
COLOR Text_Colour: PRINT "de:";
LOCATE screen_offset + 22, 22: COLOR Data_Colour
IF sample_mode = 1 THEN PRINT "High Speed";
IF sample_mode = 2 THEN PRINT "Timed";


LOCATE screen_offset + 24, 8: COLOR Highlight_Colour: PRINT "T";
COLOR Text_Colour: PRINT "otal number of samples:";
LOCATE screen_offset + 24, 32: COLOR Data_Colour: PRINT Number_Samples;

IF sample_mode = 2 THEN

    LOCATE screen_offset + 26, 8: COLOR Text_Colour: PRINT "Sample every:";
    COLOR Data_Colour: PRINT Hours_per_Sample;
    LOCATE screen_offset + 26, 28: COLOR Highlight_Colour: PRINT "H";
    COLOR Text_Colour: PRINT "ours";

    LOCATE screen_offset + 27, 21: COLOR Data_Colour: PRINT Minutes_per_Sample;
    LOCATE screen_offset + 27, 28: COLOR Highlight_Colour: PRINT "M";
    COLOR Text_Colour: PRINT "inutes";

    LOCATE screen_offset + 28, 21: COLOR Data_Colour: PRINT Seconds_per_Sample
    LOCATE screen_offset + 28, 28: COLOR Highlight_Colour: PRINT "S";
    COLOR Text_Colour: PRINT "econds";

    LOCATE screen_offset + 29, 8: COLOR Text_Colour: PRINT "Save buffer ";
    COLOR Highlight_Colour: PRINT "e";
    COLOR Text_Colour: PRINT "very:";
    LOCATE screen_offset + 29, 28: COLOR Data_Colour: PRINT Samples_per_save;
    LOCATE screen_offset + 29, 35: COLOR Text_Colour: PRINT "samples";
END IF

END SUB

SUB Get_Input ()



LOCATE screen_offset + 26, 36: COLOR Msg_Highlight_Colour
PRINT CHR$(201); STRING$(42, 205); CHR$(187)
LOCATE screen_offset + 27, 36
PRINT CHR$(186); STRING$(42, 32); CHR$(186)
LOCATE screen_offset + 28, 36
PRINT CHR$(200); STRING$(42, 205); CHR$(188)
LOCATE screen_offset + 27, 38: COLOR Data_Colour2: PRINT Request_String$; ":>";
INPUT "", Value$



END SUB

SUB get_samples ()

LOCATE 1, 20: COLOR Text_Colour: PRINT "********  Sampling  ********";
DEF SEG = prog_seg
CALL absolute(Port, Number_Samples, Delay_Value, Status, base_address)
LOCATE 1, 20: PRINT "                            ";

END SUB

SUB Get_Scale ()




    OUT (Port + 2), 253

    Scale = 10 ^ ((INP(Port + 1) AND 128) / 128)

    OUT (Port + 2), 2
    OUT (Port + 2), 3
    OUT (Port + 2), 6


END SUB

SUB High_Speed ()


IF sampling = 1 THEN
    CALL get_samples
    IF Plot_onoff = 1 THEN
        CALL drawscreen
        CALL plotit
    END IF
    sampling = 0
    IF auto = 1 THEN quitnow = 1
END IF



END SUB

SUB init_Pocket ()

OUT (Port), &HFF

N_S% = 1
D_V% = 0
t1 = TIMER
CALL absolute(Port, N_S%, D_V%, Status, base_address)
t1 = TIMER - t1
COLOR Trace_Colour
LOCATE 10, 17: PRINT "Initalising sampler, Please wait..."
N_S% = 32000
IF Delay_Value > 10 THEN N_S% = 8000


t2 = TIMER
CALL absolute(Port, N_S%, Delay_Value, Status, base_address)
t2 = TIMER - t2
Sample_Time = (t2 - t1) / N_S%

END SUB

SUB keypress ()

user_input$ = UCASE$(INKEY$)
IF INSTR("xLPTEFHMSOCD " + CHR$(27), user_input$) > 1 THEN
  
    Keypressed = 1
    IF user_input$ = "L" THEN
        IF Plot_onoff = 1 THEN
            Plot_onoff = 0: SCREEN 0: CLS
            ELSE Plot_onoff = 1: SCREEN 12: CLS : CALL drawscreen
        END IF
        
    END IF


    IF user_input$ = "P" THEN
        Request_String$ = "Enter port address"
        CALL Get_Input
        IF LEN(Value$) = 3 THEN Port = VAL("&H" + Value$)
    END IF

    IF user_input$ = "T" THEN
        Request_String$ = "Enter number of samples to take"
        CALL Get_Input
        i = VAL(Value$)
        IF i > 2 AND i < 32000 THEN Number_Samples = INT(i)
        IF i <= 2 THEN Number_Samples = 2
        IF i >= 32000 THEN Number_Samples = 32000
        IF Number_Samples < Samples_per_save THEN Samples_per_save = Number_Samples

            IF Number_Samples <= 500 THEN
                number_to_plot = Number_Samples - 1
                screen_step = 500 / (Number_Samples - 1)
                data_step = -1

            ELSE number_to_plot = 499
                screen_step = 1
                data_step = -Number_Samples / 500
            END IF
    END IF

    IF user_input$ = "E" THEN
         Request_String$ = "How many samples before saving"
        CALL Get_Input
        i = VAL(Value$)
        IF i >= 1 AND i <= Number_Samples THEN Samples_per_save = INT(i)
        IF i <= 0 THEN Samples_per_save = Number_Samples
        IF i > Number_Samples THEN Samples_per_save = Number_Samples
    END IF

    IF user_input$ = "F" THEN
        Request_String$ = "Enter file name"
        CALL Get_Input

        l = LEN(Value$)
        IF l > 0 THEN
            Filename$ = ""

            FOR i = 1 TO LEN(Value$)
                A$ = MID$(Value$, i, 1)
                IF A$ <> "." THEN Filename$ = Filename$ + A$
            NEXT

            IF LEN(Filename$) > 8 THEN Filename$ = LEFT$(Filename$, 8)
            Filename$ = Filename$ + ".PKT"
        END IF
    END IF

    IF user_input$ = "O" THEN
        sample_mode = sample_mode + 1
        IF sample_mode = 3 THEN sample_mode = 1
    END IF

    IF sample_mode = 1 THEN

    END IF

    IF sample_mode = 2 THEN
        IF user_input$ = "H" THEN
            Request_String$ = "Enter number of hours"
            CALL Get_Input
            i = VAL(Value$)
            Hours_per_Sample = i
            IF i < 0 THEN Hours_per_Sample = 0
            IF i > 11 THEN Hours_per_Sample = 11
            IF Hours_per_Sample + Minutes_per_Sample + Seconds_per_Sample = 0 THEN Seconds_per_Sample = .1
            Its_Time_To_Sample = 1
            this_sample = 1
            sampling = 0

        END IF

        IF user_input$ = "M" THEN
            Request_String$ = "Enter number of minutes"
            CALL Get_Input
            i = VAL(Value$)
            Minutes_per_Sample = i
            IF i < 0 THEN Minutes_per_Sample = 0
            IF i > 59 THEN Minutes_per_Sample = 59
            IF Hours_per_Sample + Minutes_per_Sample + Seconds_per_Sample = 0 THEN Seconds_per_Sample = .1
            Its_Time_To_Sample = 1
            this_sample = 1
            sampling = 0

        END IF

        IF user_input$ = "S" THEN
            Request_String$ = "Enter number of seconds"
            CALL Get_Input
            i = VAL(Value$)
            Seconds_per_Sample = i
            IF i < .1 THEN Seconds_per_Sample = .1
            IF i > 59 THEN Seconds_per_Sample = 59
            IF i = 0 AND Hours_per_Sample + Minutes_per_Sample <> 0 THEN Seconds_per_Sample = 0
            IF Hours_per_Sample + Minutes_per_Sample + Seconds_per_Sample = 0 THEN Seconds_per_Sample = .1
            Its_Time_To_Sample = 1
            this_sample = 1
            sampling = 0
        END IF
    END IF

    IF user_input$ = "C" THEN
        Request_String$ = "Enter speed factor"
        CALL Get_Input
        i = VAL(Value$)
        IF i >= 0 AND i < 32 THEN Delay_Value = INT(i)
        IF i < 0 THEN Delay_Value = 0
        IF i >= 32 THEN Delay_Value = 32
        CALL init_Pocket
        CALL drawscreen
    END IF


    IF user_input$ = " " THEN
        sampling = 1
    data_start = 336 + Number_Samples
    this_sample = 1
        CALL drawscreen
    IF sample_mode = 2 THEN COLOR Text_Colour: LOCATE screen_offset + 20, 24: PRINT "Sampling Started at "; TIME$

    END IF

    IF user_input$ = "D" THEN
    
        IF sample_mode = 1 THEN
            CALL Save_All
        ELSE CALL save_one
        END IF
    END IF

    IF user_input$ = CHR$(27) THEN
    sampling = 0

    LOCATE screen_offset + 20, 24: PRINT "     Sampling stopped       "
    END IF
END IF

END SUB

SUB LoadMC ()



END SUB

SUB load_Config ()


ON LOCAL ERROR GOTO ErrHandler
ErrorFlag = 0

IF LEN(COMMAND$) > 0 THEN
Current_Config$ = COMMAND$
auto = 1
    ELSE Current_Config$ = "POCKET.CFG"
END IF


 OPEN Current_Config$ FOR INPUT AS #2
 IF ErrorFlag = 0 THEN
    LOCATE 3, 27: PRINT "Loading Configuration file:"
    PRINT
    PRINT TAB(40 - (LEN(Current_Config$) / 2)); Current_Config$
                                           
    FOR i = 1 TO 14
        LINE INPUT #2, A$
    NEXT

    INPUT #2, A$: Trace_Colour = VAL(A$)
    INPUT #2, A$: Trace_Background_Colour = VAL(A$)
    INPUT #2, A$: Grid_Colour = VAL(A$)
    INPUT #2, A$: Centre_Line_Colour = VAL(A$)
    INPUT #2, A$: Scale_Text_Colour = VAL(A$)
    INPUT #2, A$: Highlight_Colour = VAL(A$)
    INPUT #2, A$: Text_Colour = VAL(A$)
    INPUT #2, A$: Data_Colour = VAL(A$)
    INPUT #2, A$: Highlight_Colour2 = VAL(A$)
    INPUT #2, A$: Text_Colour2 = VAL(A$)
    INPUT #2, A$: Data_Colour2 = VAL(A$)
    INPUT #2, A$: Msg_Colour = VAL(A$)
    INPUT #2, A$: Msg_Highlight_Colour = VAL(A$)
    INPUT #2, A$: Volt_per_Div = VAL(A$)
    INPUT #2, A$: Samples_per_Tick = VAL(A$)
    INPUT #2, A$: Delay_Value = VAL(A$)
    INPUT #2, A$: sample_mode = VAL(A$)
    INPUT #2, A$: Hours_per_Sample = VAL(A$)
    INPUT #2, A$: Minutes_per_Sample = VAL(A$)
    INPUT #2, A$: Seconds_per_Sample = VAL(A$)
    INPUT #2, A$: Number_Samples = VAL(A$)
    INPUT #2, A$: Samples_per_save = VAL(A$)
    INPUT #2, A$: Port = VAL("&H" + A$)
    INPUT #2, A$: Plot_onoff = VAL(A$)
    INPUT #2, A$: Filename$ = LEFT$(A$, 12)
    CLOSE #2
    ELSE
        LOCATE 7, 17
        PRINT "No Config. file found, loading default values."
END IF

ErrHandler:
ErrorFlag = 1
RESUME NEXT

END SUB

SUB plotit ()

IF Status = 0 THEN
    data_start = 336 + Number_Samples

    PSET (x_min, y_max - PEEK(data_start)), Trace_Colour

    FOR i = 0 TO number_to_plot
        x = i * screen_step
        LINE -(x_min + x, y_max - PEEK(data_start + i * data_step)), Trace_Colour
    NEXT

END IF
CALL print_Scale

END SUB

SUB plotone ()

IF Status = 0 THEN

    PSET (x_min, y_max - y(1)), Trace_Colour

    FOR i = 1 TO this_sample
        x = i * screen_step
        LINE -(x_min + x, y_max - y(i * -data_step)), Trace_Colour
    NEXT

END IF
CALL print_Scale

END SUB

SUB print_Scale ()



    COLOR Scale_Text_Colour

    LOCATE 18, 2: PRINT "0V"
    LOCATE 10, 1: PRINT RIGHT$(STR$(Scale), 2); "V";
    LOCATE 2, 1: PRINT RIGHT$(STR$(Scale * 2), 2); "V"

END SUB

SUB Save_All ()


IF Status = 0 THEN

    data_start = 336 + Number_Samples
    COLOR Text_Colour: LOCATE 1, 20: PRINT "********   Saving   ********";

    OPEN Filename$ FOR OUTPUT AS #2
    PRINT #2, "           Data file from POCKET.EXE"
    PRINT #2, "      Driver program for the Pocket Sampler."
    PRINT #2, "       Electronics Australia, August 1996."
    PRINT #2, "     File created at "; TIME$; " on "; DATE$
    PRINT #2,
    PRINT #2,
    PRINT #2, "        Total number of samples =    "; Number_Samples
    PRINT #2, "   Single sample time (seconds) =    "; Sample_Time
    PRINT #2, "Total sampling period (seconds) =    "; Sample_Time * Number_Samples
    PRINT #2, "          Voltage scale (volts) =    "; Scale * 2
    PRINT #2,
    PRINT #2,
    FOR i = 0 TO Number_Samples
        PRINT #2, USING "##.###"; PEEK(data_start - i) * Full_Scale * Scale / 255
    NEXT
    CLOSE #2
    LOCATE 1, 20: PRINT "                            ";

END IF


END SUB

SUB Save_Config ()
OPEN Current_Config$ FOR OUTPUT AS #2
PRINT #2, "        Configuration file for POCKET.EXE          "
PRINT #2, "      Driver program for the Pocket Sampler.       "
PRINT #2, "                                                   "
PRINT #2, "  Numbers in brackets indicate default values.     "
PRINT #2, "                                                   "
PRINT #2, "NOTE: Do not alter the order of the items in this  "
PRINT #2, "file, as the program isn't terribly intelligent,   "
PRINT #2, "and will read in incorrect values.                 "
PRINT #2, "Note also that the program starts reading from the "
PRINT #2, "fifteenth line of this file, so don't add any extra"
PRINT #2, "text to the top of the file.                       "
PRINT #2, "(To generate a default config. file, simply move or"
PRINT #2, "delete this file and then run and exit POCKET.EXE.)"
PRINT #2, "vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv"
PRINT #2, Trace_Colour; "Trace_Colour (2)"
PRINT #2, Trace_Background_Colour; "Trace_Background_Colour (15)"
PRINT #2, Grid_Colour; "Grid_Colour (8)"
PRINT #2, Centre_Line_Colour; "Centre_Line_Colour (12)"
PRINT #2, Scale_Text_Colour; "Scale_Text_Colour (2)"
PRINT #2, Highlight_Colour; "Highlight_Colour (15)"
PRINT #2, Text_Colour; "Text_Colour (14)"
PRINT #2, Data_Colour; "Data_Colour (12)"
PRINT #2, Highlight_Colour2; "Highlight_Colour2 (11)"
PRINT #2, Text_Colour2; "Text_Colour2 (2)"
PRINT #2, Data_Colour2; "Data_Colour2 (15)"
PRINT #2, Msg_Colour; "Msg_Colour (4)"
PRINT #2, Msg_Highlight_Colour; "Msg_Highlight_Colour (13)"
PRINT #2, Volt_per_Div; "Volt_per_Div (0.25)"
PRINT #2, Samples_per_Tick; "Samples_per_Tick (100)"
PRINT #2, Delay_Value; "Delay_Value (0)"
PRINT #2, sample_mode; "Sample_Mode (1)"
PRINT #2, Hours_per_Sample; "Hours_per_Sample (0)"
PRINT #2, Minutes_per_Sample; "Minutes_per_Sample (0)"
PRINT #2, Seconds_per_Sample; "Seconds_per_Sample (1)"
PRINT #2, Number_Samples; "Number_Samples (500)"
PRINT #2, Samples_per_save; "Samples_per_Save (500)"
PRINT #2, " "; HEX$(Port); " Port (378)"
PRINT #2, Plot_onoff; "Plot_onoff (1)"
PRINT #2, Filename$
CLOSE #2
END SUB

SUB save_one ()

IF this_sample > 0 THEN

    LOCATE 1, 20: PRINT "********   Saving   ********";

    OPEN Filename$ FOR OUTPUT AS #2
    PRINT #2, "           Data file from POCKET.EXE"
    PRINT #2, "      Driver program for the Pocket Sampler."
    PRINT #2, "       Electronics Australia, August 1996."
    PRINT #2, "    Last data recorded at "; TIME$; " on "; DATE$
    PRINT #2, ""
    PRINT #2, ""
    PRINT #2, "                               "
    PRINT #2, "                                        "
    PRINT #2, "        Total number of samples =    "; this_sample
    PRINT #2, "          Voltage scale (volts) =    "; Scale * 2
    PRINT #2,
    PRINT #2,
        FOR i = 1 TO this_sample
            PRINT #2, USING "##.###"; y(i) * Full_Scale * Scale / 255
        NEXT
    CLOSE #2

    LOCATE 1, 20: PRINT "                            ";
END IF



END SUB

SUB setupvars ()
ON LOCAL ERROR RESUME NEXT

prog_seg = VARSEG(prog(1))
base_address = VARPTR(prog(1))
Trace_Colour = 2
Trace_Background_Colour = 15'
Grid_Colour = 8'
Centre_Line_Colour = 12'
Number_Samples = 500'
x_min = 28
x_Max = x_min + 500
y_min = 22
y_max = y_min + 255
Full_Scale = 2
Volt_per_Div = .25'
Samples_per_Tick = 100'
Samples_per_save = 500'
Hours_per_Sample = 0'
Minutes_per_Sample = 0'
Seconds_per_Sample = 1'
Scale_Text_Colour = 2'
Highlight_Colour = 15'
Text_Colour = 14'
Data_Colour = 12'
Highlight_Colour2 = 11'
Text_Colour2 = 2'
Data_Colour2 = 15'
Msg_Colour = 4'
Msg_Highlight_Colour = 13'
Port = &H378'
Status = 0
Delay_Value = 0'
sample_mode = 1'
Plot_onoff = 1'
Filename$ = "DEFAULT.PKT"'
auto = 0
quitnow = 0

CALL load_Config
    IF Number_Samples <= 500 THEN
        number_to_plot = Number_Samples - 1
        screen_step = 500 / (Number_Samples - 1)
        data_step = -1

        ELSE number_to_plot = 499
            screen_step = 1
            data_step = -Number_Samples / 500
    END IF


END SUB

SUB waiting ()


Total_Time = Hours_per_Sample * 3600 + Minutes_per_Sample * 60 + Seconds_per_Sample

IF sampling = 1 AND Its_Time_To_Sample = 1 THEN
    T = TIMER

    
    Temp = Number_Samples
    Number_Samples = 10
    Temp2 = Delay_Value
    Delay_Value = 32

    CALL get_samples

    Number_Samples = Temp
    Delay_Value = Temp2
    Temp = 0
    DEF SEG = prog_seg
    data_start = 336 + 10
    FOR i = 0 TO 9
        Temp = Temp + PEEK(data_start - i)
    NEXT

    y(this_sample) = Temp / 10
    IF (this_sample / Samples_per_save) = INT(this_sample / Samples_per_save) THEN CALL save_one
    IF Plot_onoff = 1 THEN CALL plotone

    Its_Time_To_Sample = 0
    this_sample = this_sample + 1

    IF this_sample = Number_Samples THEN
        sampling = 0
        LOCATE screen_offset + 20, 24: PRINT "Sampling stopped at "; TIME$
        CALL save_one
        this_sample = 1
        IF auto = 1 THEN quitnow = 1
    END IF

END IF

CALL keypress

Elapsed_time = TIMER - T
IF Elapsed_time < 0 THEN Elapsed_time = Elapsed_time + 86400
IF Elapsed_time >= Total_Time THEN Its_Time_To_Sample = 1


END SUB

